/***************************************************************************
                          palettecfg.h  -  description
                             -------------------
    begin                : lun abr 15 2002
    Copyright	Giuseppe Della Bianca<giusdbg@gmail.com>

    original author	 : Miguel Novas
    email                : michaell@teleline.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PALETTECFG_H
#define PALETTECFG_H

#include "ksensorssetting.h"
#include <palettecfgdesign.h>

/**
  *@original author Miguel Novas
  */

class PaletteCfg : public PaletteCfgDesign, public ksensorsSetting
{
Q_OBJECT
public:
  PaletteCfg( QWidget *parent = nullptr, const QString &name = QString() );
	~PaletteCfg();

  void readPalette( const QString sensorShortName, const QString sensorLongName, const QString sensorSubName );
  void savePalette();

protected Q_SLOTS:

  void slotComboSelected(int index);
  void slotColorChanged(const QColor &newColor);
  void slotPaletteDefault();

private:

  bool palDefault;

    QString shortName;
    QString longName;
    QString subName;

  void setPanelPalette(const QPalette &pal, bool updateColorButton=false);

};

#endif
