/***************************************************************************
    file:           sensorpanel.h
    description:    sensors panel widget
    begin:          09/06/2024
    Copyright:      Giuseppe Della Bianca<giusdbg@gmail.com>
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SENSORPANEL_H
#define SENSORPANEL_H

#include <qstring.h>

#include "qdialarc.h"
#include "qbarmeter.h"
#include "qlcdstring.h"

#include "panel.h"
#include "sensor.h"
#include "qlchart.h"
#include "panelswindow.h"


class PanelsWindow;

class SensorPanel : public Panel  {
   Q_OBJECT
public: 

    SensorPanel( PanelsWindow *panelsWindowIn, Sensor *newSensor, const QString &name = QString() );
    ~SensorPanel();

    void updateValue();
        
public Q_SLOTS:

  void setValue( /* double value, double value1, double value2, double value3, double value4 */ );

  void slotUpdateConfig();

Q_SIGNALS:

  void panelDockConfigChanged();

protected:

  void resizeEvent ( QResizeEvent * ) override;

  void createTitleWidget();
  void createGraphicWidget();
  void createValueWidget();

  void timerEvent( QTimerEvent * ) override;
  void changeEvent ( QEvent * event ) override;

private:

  Sensor     *sensor;
  PanelsWindow *panelsWindow;

    QLineChart *qlChart;

  QDialArc   *arc;
  QBarMeter *barMeter;
  QLCDString *lcdDes;
  QLCDString *lcdVal;  
  QLCDString *lcdVal1; 
  QLCDString *lcdVal2;
  QLCDString *lcdVal3;
  QLCDString *lcdVal4;
  QLCDString *lcdDes1;
  QLCDString *lcdDes2;
  
  struct Sensor::stValMask vMask;
  bool       alarm;
  int        idTimer;
};

#endif
